# heatxsink's keymap for kinesis advantage w/ kinx

## my keymap has three objectives ...
1. Make it easy to add keyboard layouts (layers).
2. Easy to swap between keyboard layouts (layers).
3. Use LED indicators on the kinX controller to provide feedback as to what layer is selected.

## layer description
0. DEFAULT (function key row, number row, left/right gutter keys, and thumb keys)
1. QWERTY
2. CMMDH [Colemak Mod-DH](https://colemakmods.github.io/mod-dh/)
3. WM    [Workman](https://workmanlayout.org/)
3. Keypad (number pad on the right, media keys on the left)

## layers
```
Keymap: DEFAULT
Description: keys separated by "/" tap for first, hold for second; uses Space Cadet Shifts

 ,-------------------------------------------------------------------------------------------------------------------.
 | Esc    |  F1  |  F2  |  F3  |  F4  |  F5  |  F6  |  F8  |  F9  |  F10 |  F12 | PSCR | SLCK | PAUS |KEYPAD|  BOOT  |
 |--------+------+------+------+------+------+---------------------------+------+------+------+------+------+--------|
 | =+     |  1!  |  2@  |  3#  |  4$  |  5%  |                           |  6^  |  7&  |  8*  |  9(  |  0)  | -_     |
 |--------+------+------+------+------+------|                           +------+------+------+------+------+--------|
 | Tab    |      |      |      |      |      |                           |      |      |      |      |      | \|     |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |ESC/CTRL|      |      |      |      |      |                           |      |      |      |      |      | '"     |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |SC_Shift|      |      |      |      |      |                           |      |      |      |      |      |SC_Shift|
 `--------+------+------+------+------+------'                           `------+------+------+------+------+--------'
          | `~   |LAYERS| Left | Right|                                         | Up   | Down |  [{  |  ]}  |
          `---------------------------'                                         `---------------------------'
                                        ,-------------.         ,-------------.
                                        | ALT  | CTRL |         | CTRL  | GUI |
                                 ,------|------|------|         |------+------+------.
                                 |      |      | Home |         | PgUp |      |      |
                                 | BkSp | Del  |------|         |------|Return| Space|
                                 |      |      | End  |         | PgDn |      |      |
                                 `--------------------'         `--------------------'

Keymap: LAYERS 
Description: OSL that allows for easy switching between layers.

 ,-------------------------------------------------------------------------------------------------------------------.
 |        |      |      |      |      |      |      |      |      |      |      |      |      |      |      |        |
 |--------+------+------+------+------+------+---------------------------+------+------+------+------+------+--------|
 |        |QWERTY|CMMDH |WM    |KEYPAD|      |                           |      |      |      |      |      |        |
 |--------+------+------+------+------+------|                           +------+------+------+------+------+--------|
 |        |      |      |      |      |      |                           |      |      |      |      |      |        |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |        |      |      |      |      |      |                           |      |      |      |      |      |        |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |        |      |      |      |      |      |                           |      |      |      |      |      |        |
 `--------+------+------+------+------+------'                           `------+------+------+------+------+--------'
          |      |      |      |      |                                         |      |      |      |      |
          `---------------------------'                                         `---------------------------'
                                        ,-------------.         ,-------------.
                                        |      |      |         |      |      |
                                 ,------|------|------|         |------+------+------.
                                 |      |      |      |         |      |      |      |
                                 |      |      |------|         |------|      |      |
                                 |      |      |      |         |      |      |      |
                                 `--------------------'         `--------------------'

Keymap: QWERTY

 ,-------------------------------------------------------------------------------------------------------------------.
 |        |      |      |      |      |      |      |      |      |      |      |      |      |      |      |        |
 |--------+------+------+------+------+------+---------------------------+------+------+------+------+------+--------|
 |        |      |      |      |      |      |                           |      |      |      |      |      |        |
 |--------+------+------+------+------+------|                           +------+------+------+------+------+--------|
 |        |   Q  |   W  |   E  |   R  |   T  |                           |   Y  |   U  |   I  |   O  |   P  |        |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |        |   A  |   S  |   D  |   F  |   G  |                           |   H  |   J  |   K  |   L  |  ;:  |        |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |        |   Z  |   X  |   C  |   V  |   B  |                           |   N  |   M  |  ,.  |  .>  |  /?  |        |
 `--------+------+------+------+------+------'                           `------+------+------+------+------+--------'
          |      |      |      |      |                                         |      |      |      |      |
          `---------------------------'                                         `---------------------------'
                                        ,-------------.         ,-------------.
                                        |      |      |         |      |      |
                                 ,------|------|------|         |------+------+------.
                                 |      |      |      |         |      |      |      |
                                 |      |      |------|         |------|      |      |
                                 |      |      |      |         |      |      |      |
                                 `--------------------'         `--------------------'

Keymap: CMMDH (Colemak Mod-DH)

 ,-------------------------------------------------------------------------------------------------------------------.
 |        |      |      |      |      |      |      |      |      |      |      |      |      |      |      |        |
 |--------+------+------+------+------+------+---------------------------+------+------+------+------+------+--------|
 |        |      |      |      |      |      |                           |      |      |      |      |      |        |
 |--------+------+------+------+------+------|                           +------+------+------+------+------+--------|
 |        |   Q  |   W  |   F  |   P  |   B  |                           |   J  |   L  |   U  |   Y  |  ;:  |        |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |        |   A  |   R  |   S  |   T  |   G  |                           |   M  |   N  |   E  |   I  |  O   |        |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |        |   Z  |   X  |   C  |   D  |   V  |                           |   K  |   H  |  ,.  |  .>  |  /?  |        |
 `--------+------+------+------+------+------'                           `------+------+------+------+------+--------'
          |      |      |      |      |                                         |      |      |      |      |
          `---------------------------'                                         `---------------------------'
                                        ,-------------.         ,-------------.
                                        |      |      |         |      |      |
                                 ,------|------|------|         |------+------+------.
                                 |      |      |      |         |      |      |      |
                                 |      |      |------|         |------|      |      |
                                 |      |      |      |         |      |      |      |
                                 `--------------------'         `--------------------'

Keymap: WM (Workman)

 ,-------------------------------------------------------------------------------------------------------------------.
 |        |      |      |      |      |      |      |      |      |      |      |      |      |      |      |        |
 |--------+------+------+------+------+------+---------------------------+------+------+------+------+------+--------|
 |        |      |      |      |      |      |                           |      |      |      |      |      |        |
 |--------+------+------+------+------+------|                           +------+------+------+------+------+--------|
 |        |   Q  |   D  |   R  |   W  |   B  |                           |   J  |   F  |   U  |   P  |  ;:  |        |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |        |   A  |   S  |   H  |   T  |   G  |                           |   Y  |   N  |   E  |   O  |  I   |        |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |        |   Z  |   X  |   M  |   C  |   V  |                           |   K  |   L  |  ,.  |  .>  |  /?  |        |
 `--------+------+------+------+------+------'                           `------+------+------+------+------+--------'
          |      |      |      |      |                                         |      |      |      |      |
          `---------------------------'                                         `---------------------------'
                                        ,-------------.         ,-------------.
                                        |      |      |         |      |      |
                                 ,------|------|------|         |------+------+------.
                                 |      |      |      |         |      |      |      |
                                 |      |      |------|         |------|      |      |
                                 |      |      |      |         |      |      |      |
                                 `--------------------'         `--------------------'

Keymap: KEYPAD

 ,-------------------------------------------------------------------------------------------------------------------.
 |        |      |      |      |      |      |      |      |      |      |      |      |      |      |      |        |
 |--------+------+------+------+------+------+---------------------------+------+------+------+------+------+--------|
 |        |      |      |      |      |      |                           |      |NUMLCK|  =   |  /   |PASTE |        |
 |--------+------+------+------+------+------|                           +------+------+------+------+------+--------|
 |        |      | MUTE | VOL- | VOL+ |      |                           |      |   7  |   8  |   9  |  -   |        |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |        | STOP | PREV | PLAY | NEXT |SELECT|                           |      |   4  |   5  |   6  |  +   |        |
 |--------+------+------+------+------+------|                           |------+------+------+------+------+--------|
 |        |      |      |      |      |      |                           |      |   1  |   2  |   3  | ENTER|        |
 `--------+------+------+------+------+------'                           `------+------+------+------+------+--------'
          |      |      |      |      |                                         |   (  |   )  |   .  | ENTER|
          `---------------------------'                                         `---------------------------'
                                        ,-------------.         ,-------------.
                                        |      |      |         |      |      |
                                 ,------|------|------|         |------+------+------.
                                 |      |      |      |         |      |      |      |
                                 |      |      |------|         |------|ENTER |  0   |
                                 |      |      |      |         |      |      |      |
                                 `--------------------'         `--------------------'
```
## requirements
* K500 or K600 Kinesis Advantage MPC or Advantage 2.
* [kinx project / stapelberg controller](https://github.com/kinx-project/kint)

## shoutout(s)
* `stapelberg` self explanitory
* `jwon` for his LED indicator code
* `tuesdayjohn` for how he did layers

